rm(list=ls())
library("tseries")
library("astsa")
library("forecast")
library("TSA")
library("MASS")
library("itsmr")

install.packages("itsmr")

############
numjobs=c(5,3,6,7,8,2,4,8,9,10,4,3,4,6,7,8)
series=ts(numjobs,start=c(1997,7),frequency=12)
plot(numjobs)
plot(series)

series=ts(numjobs,start=c(1997,7),end=c(2005,12),frequency=12)

data()
AB=AirPassengers 
print(AB)
class(AB)
plot(AB)
plot(AB,ylab="Passengers",xlab="date")
end(AB)
frequency(AB)
aggregate(AB)
decompose(AB)
plot(decompose(AB))
or
yu=decompose(AB)
plot(yu)

my=c(2,3,5,7,2,8,9,3,5,6,8,9,7)
myts=ts(my,start=c(2009,1),end=c(2014,12),frequency=12)
fit=stl(myts,s.window="period")

z=rnorm(1000)
w=rnorm(1000)
for(t in 2:1000)  z[t]=z[t-1]+w[t]
plot(z,type="l")

rm(list=ls())
set.seed(1)
x=rnorm(1000)
w=rnorm(1000)
for(t in 2:1000)  x[t]=0.7*x[t-1]+w[t]
plot(x,type="l")

rm(list=ls())
set.seed(1)
x=rnorm(100)
w=rnorm(100)
for(t in 3:100)  x[t]=(5/6)*x[t-1]+(1/6)*x[t-2]+w[t]
plot(x,type="l")

rm(list=ls())
set.seed(1)
z=rnorm(100)
w=rnorm(100,20)
for(t in 2:100)  z[t]=0.8*z[t-1]+w[t]
Time=1:100
x=50+3*Time+z
plot(x,xlab="time",type="l")









a=read.csv("C:/Users/MHKZ/Desktop/gas monthly.csv",header=F)
b=ts(a,start=c(2009,3),end=c(2018,11),frequency=12)
length(b)
decompose(b)
plot(decompose(b))
plot(b)
aaa=acf(b,lag.max=30)
bbb=pacf(b,lag.max=30)
adf.test(b)
c=BoxCox.lambda(b)
d=BoxCox(b,lambda=c)
ndiffs(d)
e=diff(d,diffrence=1)
plot(e)
ccc=acf(e,lag.max=30)
ddd=pacf(e,lag.max=30)
nsdiffs(e)
f=diff(e,diffrence=1)
g=decompose(f)
h=seasadj(g)
plot(h)
decompose(h)
plot(decompose(h))
eee=acf(h,lag.max=30)
fff=pacf(h,lag.max=30)
i=BoxCox.lambda(h)
j=BoxCox(h,lambda=i)
ndiffs(j)
plot(j)
acf(j,lag.max=30)
pacf(j,lag.max=30)


arima(b,order=c(2,1,2),seasonal=c(1,1,1))
arima(b,order=c(2,1,2),seasonal=c(1,1,0))
arima(b,order=c(2,1,2),seasonal=c(0,1,1))
arima(b,order=c(2,1,2),seasonal=c(0,1,0))

arima(b,order=c(2,1,0),seasonal=c(1,1,1))
arima(b,order=c(2,1,0),seasonal=c(1,1,0))
arima(b,order=c(2,1,0),seasonal=c(0,1,1))
arima(b,order=c(2,1,0),seasonal=c(0,1,0))

arima(b,order=c(2,1,1),seasonal=c(1,1,1))
arima(b,order=c(2,1,1),seasonal=c(1,1,0))
arima(b,order=c(2,1,1),seasonal=c(0,1,1))
arima(b,order=c(2,1,1),seasonal=c(0,1,0))

arima(b,order=c(1,1,2),seasonal=c(1,1,1))
arima(b,order=c(1,1,2),seasonal=c(1,1,0))
arima(b,order=c(1,1,2),seasonal=c(0,1,1))
arima(b,order=c(1,1,2),seasonal=c(0,1,0))

arima(b,order=c(1,1,1),seasonal=c(1,1,1))
arima(b,order=c(1,1,1),seasonal=c(1,1,0))
arima(b,order=c(1,1,1),seasonal=c(0,1,1))
arima(b,order=c(1,1,1),seasonal=c(0,1,0))

arima(b,order=c(1,1,0),seasonal=c(1,1,1))
arima(b,order=c(1,1,0),seasonal=c(1,1,0))
arima(b,order=c(1,1,0),seasonal=c(0,1,1))
arima(b,order=c(1,1,0),seasonal=c(0,1,0))

arima(b,order=c(0,1,2),seasonal=c(1,1,1))
arima(b,order=c(0,1,2),seasonal=c(1,1,0))
arima(b,order=c(0,1,2),seasonal=c(0,1,1))
arima(b,order=c(0,1,2),seasonal=c(0,1,0))

arima(b,order=c(0,1,1),seasonal=c(1,1,1))
arima(b,order=c(0,1,1),seasonal=c(1,1,0))
arima(b,order=c(0,1,1),seasonal=c(0,1,1))
arima(b,order=c(0,1,1),seasonal=c(0,1,0))

arima(b,order=c(0,1,0),seasonal=c(1,1,1))
arima(b,order=c(0,1,0),seasonal=c(1,1,0))
arima(b,order=c(0,1,0),seasonal=c(0,1,1))
arima(b,order=c(0,1,0),seasonal=c(0,1,0))







auto.arima(b)
auto.arima(b,seasonal=TRUE)

RS2=arima(b,order=c(0,1,2),seasonal=c(0,1,1))

checkresiduals(RS2)
residuals=RS2$residuals
itsmr::test(residuals)

coef(RS2)

pp11=forecast(b,model=arima(b,order=c(0,1,2),seasonal=c(0,1,1)),h=5)
plot(pp11)
